---------------------------------------------------------------------------
-- ProLevels - light weight professions notifier
-- Version 1.0 28-01-2016
-- Version 1.4 25-08-2016
-- Author : RealID ReverendDave#2976
---------------------------------------------------------------------------

local ProLevels_MAX = 700
local ProLevels_MAXCoin = 10000000000
local ProLevels_CapText = { "Valor","Honor Points","Garrison Resources","Nethershard" }
local ProLevels_CapAmnt = { 5000,4000,10000,2000 }
local ProLevels_WrnAmnt = { 4500,3600,9500,1900 }
local shownit = 0 ;
						     
local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("ProLevels : " .. tostring(msg))
end

function ProLevels_OnEvent(self,event,...)

	if (event == "CHAT_MSG_SKILL") then
		ProLevel_DoProfessions()
	elseif (event == "PLAYER_MONEY" or event == "CURRENCY_DISPLAY_UPDATE") then
		ProLevel_CheckCurrencies()
	elseif (shownit == 0) then
			print("Version 1.4 ")
			ProLevel_DoProfessions()
			ProLevel_CheckCurrencies()
			shownit = 1
	end
end

function ProLevel_DoProfessions()
local p1,p2,arch,fish,cook,aid = GetProfessions()
		
	if not (p1 == nil) then
		ProLevel_CheckProfession(p1)
	end
	if not (p2 == nil) then
		ProLevel_CheckProfession(p2)
	end
	if not (arch == nil) then
		ProLevel_CheckProfession(arch)
	end
	if not (fish == nil) then
		ProLevel_CheckProfession(fish)
	end
	if not (cook == nil) then
		ProLevel_CheckProfession(cook)
	end
	if not (aid == nil) then
		ProLevel_CheckProfession(aid)
	end
end

function ProLevel_CheckProfession(index)
local name,_,lvl,max = GetProfessionInfo(index)
			
	if ((lvl >= (max - 5)) and max < ProLevels_MAX) then
		print("|cffFF0000WARNING: " .. name .. " at " .. lvl .. " of " .. max)
	end
end

function ProLevel_CheckCurrencies()

	if (GetMoney() > (ProLevels_MAXCoin - 50000000)) then
		print("|cffFF0000WARNING: GOLD at " .. GetMoney() .. ", near limit")
	end
	
	local listSize = GetCurrencyListSize();
	local n = 1
	local name,count,ctype
	local j
	
	while(n <= listSize) do
		name,_,_,_,_,count = GetCurrencyListInfo(n)
		n = n + 1
		
		j = 1
		while(j <= (#ProLevels_CapText)) do
			if ((ProLevels_CapText[j] == name) and count >= (ProLevels_WrnAmnt[j])) then
				print("|cffFF0000WARNING: "..name.." at " .. count .. ", limit is " .. ProLevels_CapAmnt[j])
				break
			end
			j = j + 1
		end
	end

end

function ProLevels_handleCmd(msg, editbox)

	ProLevel_DoProfessions()
	ProLevel_CheckCurrencies()

end

function ProLevels_OnLoad(me)
	SLASH_PROLEVELS1 = "/prolevels"
	SLASH_PROLEVELS2 = "/pl"
	SlashCmdList["PROLEVELS"] = ProLevels_handleCmd
	me:RegisterEvent("PLAYER_ENTERING_WORLD")
	me:RegisterEvent("CHAT_MSG_SKILL")
	me:RegisterEvent("PLAYER_MONEY")
	me:RegisterEvent("CURRENCY_DISPLAY_UPDATE")

end